require 'studio_game/clumsy_player'

module StudioGame
  describe ClumsyPlayer do
    before do
      $stdout = StringIO.new
      @initial_health = 100
      @boost_factor = 10
      @player = ClumsyPlayer.new("klutz", @initial_health, @boost_factor)
    end

    it "only gets half the point value for each treasure" do
      expect(@player.points).to eq(0)

      hammer = Treasure.new(:hammer, 50)
      @player.found_treasure(hammer)
      @player.found_treasure(hammer)
      @player.found_treasure(hammer)

      expect(@player.points).to eq(75)

      crowbar = Treasure.new(:crowbar, 400)
      @player.found_treasure(crowbar)

      expect(@player.points).to eq(275) 

      yielded = []
      @player.each_found_treasure do |treasure|
        yielded << treasure
      end

      expect(yielded).to eq([Treasure.new(:hammer, 75), Treasure.new(:crowbar, 200)])
    end

    it "has a boost factor" do
      expect(@player.boost_factor).to eq(10)
    end

    it "should be w00ted the same number of times as the boost_factor" do
      @player.w00t

      expect(@player.health).to eq(@initial_health + (15 * @boost_factor))
    end
  end
end
